StrongReferenceVector (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.industry

## Class StrongReferenceVector

- java.lang.Object
- - tv.amwa.maj.industry.StrongReferenceVector

-     public class StrongReferenceVector
      extends Object

  Utilities for manipulating media entities stored in a strong reference variable array (vector). These static methods ensure a consistent approach to managing elements of a set through append, prepend, get, contains and remove operations. The methods also ensure that index values are maintained so that the order of the array is preserved when it is persisted through an object relational mapping that does not support automatic index columns.

  See Also:
    `StrongReferenceSet`, `WeakReferenceVector`, `TypeDefinitionVariableArray`, `TypeDefinitionStrongObjectReference`

- - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <T extends MediaEntity> void` | `append(List<T> list, T item)`
    `static <T extends MediaEntity> void` | `appendNoClone(List<T> list, T item)`
    `static <T extends MediaEntity> boolean` | `contains(List<T> list, T item)`
    `static <T extends MediaEntity> T` | `getAt(List<T> list, int index)`
    `static <T extends MediaEntity> List<T>` | `getOptionalList(List<T> list)`
    `static <T extends MediaEntity> List<T>` | `getRequiredList(List<T> list)`
    `static <T extends MediaEntity> void` | `insert(List<T> list, int index, T item)`
    `static <T extends MediaEntity> void` | `insertNoClone(List<T> list, int index, T item)`
    `static <T extends MediaEntity> void` | `prepend(List<T> list, T item)`
    `static <T extends MediaEntity> void` | `prependNoClone(List<T> list, T item)`
    `static <T extends MediaEntity> void` | `remove(List<T> list, int index)`
    `static <T extends MediaEntity> boolean` | `remove(List<T> list, T item)`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### append

          public static final <T extends MediaEntity> void append(List<T> list,
                                                                  T item)
                                                           throws NullPointerException

      Throws:
        `NullPointerException`

    - #### appendNoClone

          public static final <T extends MediaEntity> void appendNoClone(List<T> list,
                                                                         T item)
                                                                  throws NullPointerException

      Throws:
        `NullPointerException`

    - #### prepend

          public static final <T extends MediaEntity> void prepend(List<T> list,
                                                                   T item)
                                                            throws NullPointerException

      Throws:
        `NullPointerException`

    - #### prependNoClone

          public static final <T extends MediaEntity> void prependNoClone(List<T> list,
                                                                          T item)
                                                                   throws NullPointerException

      Throws:
        `NullPointerException`

    - #### insert

          public static final <T extends MediaEntity> void insert(List<T> list,
                                                                  int index,
                                                                  T item)
                                                           throws NullPointerException,
                                                                  IndexOutOfBoundsException

      Throws:
        `NullPointerException`
        `IndexOutOfBoundsException`

    - #### insertNoClone

          public static final <T extends MediaEntity> void insertNoClone(List<T> list,
                                                                         int index,
                                                                         T item)
                                                                  throws NullPointerException,
                                                                         IndexOutOfBoundsException

      Throws:
        `NullPointerException`
        `IndexOutOfBoundsException`

    - #### getAt

          public static final <T extends MediaEntity> T getAt(List<T> list,
                                                              int index)
                                                       throws NullPointerException,
                                                              IndexOutOfBoundsException

      Throws:
        `NullPointerException`
        `IndexOutOfBoundsException`

    - #### contains

          public static final <T extends MediaEntity> boolean contains(List<T> list,
                                                                       T item)
                                                                throws NullPointerException

      Throws:
        `NullPointerException`

    - #### remove

          public static final <T extends MediaEntity> void remove(List<T> list,
                                                                  int index)
                                                           throws NullPointerException,
                                                                  IndexOutOfBoundsException

      Throws:
        `NullPointerException`
        `IndexOutOfBoundsException`

    - #### remove

          public static final <T extends MediaEntity> boolean remove(List<T> list,
                                                                     T item)
                                                              throws NullPointerException

      Throws:
        `NullPointerException`

    - #### getOptionalList

          public static final <T extends MediaEntity> List<T> getOptionalList(List<T> list)
                                                                       throws PropertyNotPresentException

      Throws:
        `PropertyNotPresentException`

    - #### getRequiredList

          public static final <T extends MediaEntity> List<T> getRequiredList(List<T> list)

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.